#ifndef __EMITTED_VALIDATE_H
#define __EMITTED_VALIDATE_H

#include <bits/stdc++.h>

typedef void (*feedback_function)(const char*, ...);

const int EXITCODE_AC = 0;
const int EXITCODE_WA = 0;

// declare a constant to be used as user_out.
const std::string FILENAME_USER_OUTPUT = "user_out";
// declare a constant to be used as input.
const std::string FILENAME_INPUT = "input";

#define USAGE "./%s\n"
// we have to define USAGE as dummy because we don't want to modify the lib. too much.

std::ifstream judge_in, judge_ans;
// another ifstream must be used for user_out;
std::ifstream user_out;

char *feedbackdir = NULL;

void vreport_feedback(const char* msg, va_list pvar) {
    assert(stderr);
    vfprintf(stderr, msg, pvar);
}

void report_feedback(const char* msg, ...) {
    va_list pvar;
    va_start(pvar, msg);
    vreport_feedback(msg, pvar);
}

void judge_message(const char* msg, ...) {
    va_list pvar;
    va_start(pvar, msg);
    vreport_feedback(msg, pvar);
}

void judge_error(const char* msg, ...) {
    va_list pvar;
    va_start(pvar, msg);
    vreport_feedback(msg, pvar);
    assert(0);
}

// cleaning up.
void cleanup() {
    fflush(stderr);
    fclose(stderr);
    fflush(stdout);
    fclose(stdout);
    judge_in.close();
    user_out.close();
}

// write another function ``scoring()`` for ac or wa.
void scoring(double score) {
    fprintf(stdout, "%.f", score + 1e-9);
}

void accept() {
    scoring(100.);
    cleanup();
    exit(EXITCODE_AC);
}

void accept_with_score(double scorevalue) {
    scoring(scorevalue);
    cleanup();
    exit(EXITCODE_AC);
}

void wrong_answer(const char* msg, ...) {
    va_list pvar;
    va_start(pvar, msg);
    vreport_feedback(msg, pvar);
    scoring(0.);
    cleanup();
    exit(EXITCODE_WA);
}

void init_io() {
    judge_in.open(FILENAME_INPUT, std::ios_base::in);
    if(judge_in.fail()) {
        judge_error("failed to open input file.\n");
    }
    user_out.open(FILENAME_USER_OUTPUT, std::ios_base::in);
    if(user_out.fail()) {
        judge_error("failed to open user output file.\n");
    }
    judge_ans.open("answer", std::ios_base::in);
    if(judge_ans.fail()) {
        judge_error("failed to open answer file.\n");
    }
}
using namespace std;
typedef int lli;
void OK(istream &ouf, feedback_function waf) {
    string t;
    if (ouf >> t)
        waf("Sai. Du lieu ra khong dung dinh dang.\n");
    judge_message("OK. Dap an duoc chap nhan!\n");
}
lli hs(int u, int v, int n) {
    return lli(u) * n + v;
}
bool check(istream &inf, istream &ans, istream &ouf, feedback_function waf) {
    #define nmax 101
    int mp[nmax * nmax];
    int deg[nmax];
    int n, m;
    inf >> n >> m;
    memset(deg, 0, sizeof deg);
    memset(mp, 0, sizeof mp);

    for (int i = 1, u, v; i <= m; i++) {
        inf >> u >> v;
        deg[u]++; deg[v]++;
        mp[hs(u, v, n)]++;
        mp[hs(v, u, n)]++;
    }
    int even = 0;
    for (int i = 1; i <= n; i++)
        even += (deg[i] & 1);
    if (even > 2) {
        int os;
        if (!(ouf >> os))
            waf("Sai. Du lieu ra khong dung dinh dang!\n");
        if (os != -1)
            waf("Sai. Khong co duong di thoa man!\n");
        OK(ouf, waf);
        return 1;
    } else {
        int u = -1, v;
        for (int i = 0; i <= m; i++) {
            if (!(ouf >> v))
                waf("Sai. Du lieu ra khong dung dinh dang!\n");
            if (v < 1 || v > n)
                waf("Sai. Du lieu ra khong dung dinh dang!\n");
            if (i > 0) {
                if (!mp[hs(u, v, n)])
                    waf("Sai. Duong di khong dung!\n");
                mp[hs(u, v, n)]--;
                mp[hs(v, u, n)]--;
            }
            u = v;
        }
    }

    OK(ouf, waf);
    return 1;
}
#endif

int main(void) {
    init_io();
    check(judge_in, judge_ans, user_out, wrong_answer);
    accept();
}
